aboutsummaryrefslogtreecommitdiff
path: root/git-bisect.sh
diff options
context:
space:
mode:
authorJunio C Hamano <junkio@cox.net>2006-02-13 23:26:53 -0800
committerJunio C Hamano <junkio@cox.net>2006-02-13 23:26:53 -0800
commit057f98eda179491c3f32c556f523e8786c2cbab5 (patch)
tree1f66dbd2ff02c31446543314e7557b09bd0a5a1a /git-bisect.sh
parent4170a19587280eeb3663a47a6fd993910de78076 (diff)
parent810255fd12536d296597a0366f514bf65c2e10f6 (diff)
downloadgit-057f98eda179491c3f32c556f523e8786c2cbab5.tar.gz
git-057f98eda179491c3f32c556f523e8786c2cbab5.tar.xz
Merge branch 'pb/bisect'
* pb/bisect: Properly git-bisect reset after bisecting from non-master head
Diffstat (limited to 'git-bisect.sh')
-rwxr-xr-xgit-bisect.sh17
1 files changed, 14 insertions, 3 deletions
diff --git a/git-bisect.sh b/git-bisect.sh
index 51e1e4417..3c024aae7 100755
--- a/git-bisect.sh
+++ b/git-bisect.sh
@@ -49,9 +49,16 @@ bisect_start() {
die "Bad HEAD - I need a symbolic ref"
case "$head" in
refs/heads/bisect*)
- git checkout master || exit
+ if [ -s "$GIT_DIR/head-name" ]; then
+ branch=`cat "$GIT_DIR/head-name"`
+ else
+ branch=master
+ fi
+ git checkout $branch || exit
;;
refs/heads/*)
+ [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
+ echo "$head" | sed 's#^refs/heads/##' >"$GIT_DIR/head-name"
;;
*)
die "Bad HEAD - strange symbolic ref"
@@ -159,7 +166,11 @@ bisect_visualize() {
bisect_reset() {
case "$#" in
- 0) branch=master ;;
+ 0) if [ -s "$GIT_DIR/head-name" ]; then
+ branch=`cat "$GIT_DIR/head-name"`
+ else
+ branch=master
+ fi ;;
1) test -f "$GIT_DIR/refs/heads/$1" || {
echo >&2 "$1 does not seem to be a valid branch"
exit 1
@@ -170,7 +181,7 @@ bisect_reset() {
esac
git checkout "$branch" &&
rm -fr "$GIT_DIR/refs/bisect"
- rm -f "$GIT_DIR/refs/heads/bisect"
+ rm -f "$GIT_DIR/refs/heads/bisect" "$GIT_DIR/head-name"
rm -f "$GIT_DIR/BISECT_LOG"
}